<?php
namespace Controller;

defined('_Sdef') or exit();

abstract class AController {
	
	protected $app;
	protected $model;
	protected $uri;
	
	protected $title;
	
	protected static $instance;
	
	public function __construct() {
		$this->app = \Slim\Slim::getInstance();

		$this->uri = $this->getUri();
		
		$this->model = $this->getModel();
		
		$this->title = 'Brightpulse | ';
	}
	
	
	public static function getInstance($prefix) {

		$class = '\Controller\\'.ucfirst($prefix).'Controller';
		
		if(self::$instance instanceof $class) {
			return self::$instance;
		}
		
		if(class_exists($class)) {
			self::$instance = new $class;
		}
		else {
			throw new \Exception('Class not found - '.$class);
		}
		
		return self::$instance;
	}
	
	
	//
	public function execute($param = array()) {
		return TRUE;
	}
	
	protected function getUri() {
		
		return TRUE;
	}
	
	protected function getModel() {
		//return new \Model\Model();
	}
	
	
	
}